#----------------------------------------------------------------------------
# mp3spy -    mp3  vkontakte.ru
# :	.chanset #chan +mp3spy
# :		!mp3a !mp3f
# :		anaesthesia #eggdrop@Rusnet
# :		http://egghelp.ru
#----------------------------------------------------------------------------
# v.1.1		+   
# v.1.11	-  url 

package require Tcl 	8.5
package require http	2.5

namespace eval mp3spy {

#----------------------------------------------------------------------------
#    (Suzi / http.tcl)
#----------------------------------------------------------------------------
	#    , ,   
	variable author			"anaesthesia"
	variable version		"01.11"
	variable date			"22-Aug-2008"

	#     
	variable unamespace		[namespace tail [namespace current]]

	#     (   )
	variable pubprefix 		{!}
	variable pubflag		{-|-}

	#    
	variable mp3music		{mp3a mp3v}
	#   
	variable mp3video		{mp3f flv}

	# pubcmd:_ "1 2 ..."
	#     ,      
	variable pub:mp3spy		"$unamespace $mp3music $mp3video"

	#    ,   
	variable msgprefix		{!}
	variable msgflag		{-|-}
	#       
	variable msg:mp3spy		${pub:mp3spy}

	#      ,      
	#     variable [pub|msg]:handler "string ..."

	#      
	#  $unick, $uhost, $uchan
	#  tcl ,    id 
	#  .
	variable requserid		{$uhost}
	
	#        id
	variable maxreqperuser	1

	#     
	variable maxrequests	5

	#   ,       , 
	#  
	variable pause			15
	
	#  -
	#   "proxyhost.dom:proxyport"   ,  -
	#  
	variable proxy 			{}

	#   ,   "" --  
	# ,         --  
	#  "no"        
	#         
	# (      ,     )
	variable flagactas		""
	
	#   ,   /   
	#          
	#        
	#      

	variable chflag			"$flagactas$unamespace"
	setudef  flag 			$chflag

#----------------------------------------------------------------------------
#   
#----------------------------------------------------------------------------
	#    --     
	#     
	variable logrequests	{'$unick', '$uhost', '$handle', '$uchan', '$ustr'}
	
	#     ,   --  
	#  $uchan & $unick
	variable pubsend		{PRIVMSG $uchan :}

	#     ,   --  
	#   $unick ($uchan == $unick)
	variable msgsend		{PRIVMSG $unick :}
	
	#    / 
	#  $unick
	variable errsend		{NOTICE $unick :}

	#      
	variable maxredir		1
	
	#    ,   30 
	variable timeout		30000

	#    
	variable err_ok			{  }

	#     ,     
	#       
	variable err_fail		{     .      -.}

	#     
	variable err_queue_full	{           .   .}
	
	#       id
	variable err_queue_id	{    .}
	
	#          
	#   $timewait --  ,   
	#   
	variable err_queue_time {   .       $timewait .}
	
#----------------------------------------------------------------------------
#     
#----------------------------------------------------------------------------
	# ,     
	variable 		furl		"http://www.pleera.net/"

	#   
	variable maxres		1

	variable 		reqqueue
	array unset 	reqqueue
	variable 		laststamp
	array unset		laststamp 
	variable		updinprogress	0
	variable		updatetimeout	60000

#---body---

	proc msg:mp3spy {unick uhost handle str} {pub:mp3spy $unick $uhost $handle $unick $str ; return}

	proc pub:mp3spy {unick uhost handle uchan str} {

		variable requserid ; variable furl ; variable chflag ; variable flagactas ; variable errsend ; variable mpage		
		variable mstr ; variable maxres ; variable pubprefix ; variable pubsend
		variable msgsend ; variable unamespace ; variable logrequests ; variable mp3music ; variable mp3video ; variable type

		set id [subst -nocommands $requserid]
		set prefix [subst -nocommands $errsend]
		if {$unick ne $uchan} {if {![channel get $uchan $chflag] ^ $flagactas eq "no" } {return}}
		set why [queue_isfreefor $id]
		if {$why != ""} {lput puthelp $why $prefix ; return}

#---
	if {[regexp -nocase -- {^-(\d+)} $str -> mpg]} {set mpage $mpg ; regsub -- {-\d+\s+} $str "" str} {set mpage 1}
	set ustr $str

		if {$ustr == ""} {
			if {$uchan eq $unick} {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $pubsend]}
			lput puthelp "\002\002: $pubprefix[lindex $mp3music 0] \[-\] <> -  mp3" $prefix		
			lput puthelp "\002\002: $pubprefix[lindex $mp3video 0] \[-\] <> -  " $prefix		
			return
		} else {
			set ustr [string map {" " "+"} $ustr]
			if {[string trimleft $::lastbind $pubprefix] in $mp3music} {
				set mstr [expr ($mpage + 100) / 100]
				set fetchurl "${furl}vkontakte.php?q=" ; set type 1
			} {
				set mstr [expr ($mpage + 100) / 100]
				set fetchurl "${furl}vkontakte.video.php?q=" ; set type 0
			}	
		}

		if {$logrequests ne ""} {set logstr [subst -nocommands $logrequests] ; lput putlog $logstr "$unamespace: "}
		::http::config -useragent "Mozilla/4.0 (compatible; MSIE 4.01; Windows CE; PPC; 240x320)"	

		if {[queue_add "$fetchurl[uenc $ustr]&page=$mstr" $id "[namespace current]::mp3spy:parser" [list $unick $uhost $uchan {}]]} {
			variable err_ok ; if {$err_ok ne ""} {lput puthelp "$err_ok." $prefix}
		} {variable err_fail ; if {$err_fail ne ""} {lput puthelp $err_fail $prefix}}

	return
	}

#---parser
	proc mp3spy:parser {errid errstr body extra} {
		upvar $errid lerrid $errstr lerrstr $body lbody $extra lextra
		variable err_fail ; variable pubsend ; variable msgsend ; variable errsend ; variable useurl ; variable maxres ; variable mpage ; variable mstr ; variable type

		foreach {unick uhost uchan ustr} $lextra {break}
		if {$lerrid ne {ok}} {lput putserv [subst -nocommands $err_fail] [subst -nocommands $errsend] ; return}
		if {$uchan eq $unick} {set prefix [subst -nocommands $msgsend]} {set prefix [subst -nocommands $pubsend]}
		if {[info exists ::sp_version]} {set str [encoding convertfrom cp1251 $lbody]} {set str $lbody}

#----------------------------------------------------------------------------
##---parser-specific------
#----------------------------------------------------------------------------

	if {$type} {
		if {![regexp -nocase -- {<br><b>Found: ~(\d+) tracks!</b><hr>} $str -> mall]} {set mall 0}
			if {[regexp -nocase -- {<br><br>(.*?)<br><b>} $str -> mpdata]} {
			regsub -all -- "\n|\r" $mpdata {} mpdata
			regsub -all -- "<br>" $mpdata "\n" mpdata
			set cnt 0; set mout ""
				foreach mpline [split $mpdata \n] {
					if {[regexp -nocase -- {#(\d+)\.&nbsp; <a href=\'(.*?)\' target=\'_blank\'>(.*?)</a>(.*?)$} $mpline -> mnum mlink mname mdur]} {
						regsub -all -- "<b>|</b>" $mname "\002" mname
						incr cnt
					}
					if {$cnt == [expr $mpage - (100 * ($mstr - 1))]} {append mout "([expr $cnt + (100 * ($mstr - 1))]/$mall): [sconv $mname] $mdur @ \037\00312$mlink\003\037"; break}
				}
			lput putserv "[sconv $mout]" $prefix
		} {lput putserv "\037  \037." $prefix}
	} {
		if {![regexp -nocase -- {<br><b>: ~(\d+)  !</b><hr>} $str -> vall]} {set vall 0}
			if {[regexp -nocase -- {<br><br>(.*?)<br><b>} $str -> vdata]} {
			regsub -all -- "\n|\r" $vdata {} vdata
			regsub -all -- "<br><br>" $vdata "\n" vdata
			set cnt 0; set mout ""
				foreach vline [split $vdata \n] {
					if {[regexp -nocase -- {#(\d+)\.&nbsp; <a href=\'(.*?)\' target=\'_blank\'>(.*?)</a><br>(.*?)<br>.*?<div class="adesc">(.*?)<div class="ainfo">} $vline -> vnum vlink vname vdate vdesc]} {
						regsub -all -- "<b>|</b>" $vname "\002" vname
						regsub -all -- "</div>" $vdesc " :: " vdesc					
						regsub -all -- "<.*?>" $vdesc " " vdesc					
						incr cnt
					}
					if {$cnt == [expr {$mpage - (100 * ($mstr - 1))}]} {append mout "([expr $cnt + (100 * ($mstr - 1))]/$vall): [sconv $vname] :: [sspace [sconv $vdesc]] \[$vdate\] @ \037\00312$vlink\003\037"; break}
				}
			lput putserv "[sconv $mout]" $prefix
		} {lput putserv "\037  \037." $prefix}

	}

return
}		
#----------------------------------------------------------------------------
##---ok------
#----------------------------------------------------------------------------
	proc tolow  {strr} {return [string tolower [string map {                                                                 } $strr]]}
	proc sspace {strr} {return [string trim [regsub -all {[\t\s]+} $strr { }]]}

	proc uenc {strr} {
	set str ""
		foreach byte [split [encoding convertto cp1251 $strr] ""] {scan $byte %c i ; if {[string match {[%<>"]} $byte] || $i < 65 || $i > 122} {append str [format %%%02X $i]} {append str $byte}}
	return [string map {%3A : %2D - %2E . %30 0 %31 1 %32 2 %33 3 %34 4 %35 5 %36 6 %37 7 %38 8 %39 9 \[ %5B \\ %5C \] %5D \^ %5E \_ %5F \` %60} $str]
    }

	proc sconv {strr} {
	set escapes {
        &nbsp; \x20 &quot; \x22 &amp; \x26 &apos; \x27 &ndash; \x2D
        &lt; \x3C &gt; \x3E &tilde; \x7E &euro; \x80 &iexcl; \xA1
        &cent; \xA2 &pound; \xA3 &curren; \xA4 &yen; \xA5 &brvbar; \xA6
        &sect; \xA7 &uml; \xA8 &copy; \xA9 &ordf; \xAA &laquo; \xAB
        &not; \xAC &shy; \xAD &reg; \xAE &hibar; \xAF &deg; \xB0
        &plusmn; \xB1 &sup2; \xB2 &sup3; \xB3 &acute; \xB4 &micro; \xB5
        &para; \xB6 &middot; \xB7 &cedil; \xB8 &sup1; \xB9 &ordm; \xBA
        &raquo; \xBB &frac14; \xBC &frac12; \xBD &frac34; \xBE &iquest; \xBF
        &Agrave; \xC0 &Aacute; \xC1 &Acirc; \xC2 &Atilde; \xC3 &Auml; \xC4
        &Aring; \xC5 &AElig; \xC6 &Ccedil; \xC7 &Egrave; \xC8 &Eacute; \xC9
        &Ecirc; \xCA &Euml; \xCB &Igrave; \xCC &Iacute; \xCD &Icirc; \xCE
        &Iuml; \xCF &ETH; \xD0 &Ntilde; \xD1 &Ograve; \xD2 &Oacute; \xD3
        &Ocirc; \xD4 &Otilde; \xD5 &Ouml; \xD6 &times; \xD7 &Oslash; \xD8
        &Ugrave; \xD9 &Uacute; \xDA &Ucirc; \xDB &Uuml; \xDC &Yacute; \xDD
        &THORN; \xDE &szlig; \xDF &agrave; \xE0 &aacute; \xE1 &acirc; \xE2
        &atilde; \xE3 &auml; \xE4 &aring; \xE5 &aelig; \xE6 &ccedil; \xE7
        &egrave; \xE8 &eacute; \xE9 &ecirc; \xEA &euml; \xEB &igrave; \xEC
        &iacute; \xED &icirc; \xEE &iuml; \xEF &eth; \xF0 &ntilde; \xF1
        &ograve; \xF2 &oacute; \xF3 &ocirc; \xF4 &otilde; \xF5 &ouml; \xF6
        &divide; \xF7 &oslash; \xF8 &ugrave; \xF9 &uacute; \xFA &ucirc; \xFB
        &uuml; \xFC &yacute; \xFD &thorn; \xFE &yuml; \xFF
	}
	set strr [string map $escapes [join [lrange [split $strr] 0 end]]]; 
    regsub -all -- {\[} $strr "\\\[" strr
    regsub -all -- {\]} $strr "\\\]" strr
    regsub -all -- {\(} $strr "\\\(" strr
    regsub -all -- {\)} $strr "\\\)" strr
  	regsub -all -- {&#([[:digit:]]{1,5});} $strr {[format %c [string trimleft "\1" "0"]]} strr
 	regsub -all -- {&#x([[:xdigit:]]{1,4});} $strr {[format %c [scan "\1" %x]]} strr
 	regsub -all -- {&#?[[:alnum:]]{2,7};} $strr "" strr
	return [subst -novariables $strr]
	}

	proc lput {cmd str {prefix {}} {maxchunk 420}} {
	set buf1 ""; set buf2 [list]
		foreach word [split $str] {append buf1 " " $word ; if {[string length $buf1]-1 >= $maxchunk} {lappend buf2 [string range $buf1 1 end] ; set buf1 ""}}
		if {$buf1 != ""} {lappend buf2 [string range $buf1 1 end]}
		foreach line $buf2 {$cmd $prefix$line}

	return
	}

	proc queue_isfreefor {{id {}}} {
		variable reqqueue ; variable maxreqperuser ; variable maxrequests ; variable laststamp ; variable pause
		variable err_queue_full	; variable err_queue_id ; variable err_queue_time 

		if {[info exists laststamp(stamp,$id)]} {
			set timewait [expr {$laststamp(stamp,$id) + $pause - [unixtime]}]
			if {$timewait > 0} {return [subst -nocommands $err_queue_time]}			
		}
		if {[llength [array names reqqueue -glob "*,$id"]] >= $maxreqperuser} {return $err_queue_id}
		if {[llength [array names reqqueue]] >= $maxrequests} {return $err_queue_full}
		
	return
	}

	proc queue_add {newurl id parser extra {redir 0}} {
		variable reqqueue ; variable proxy ; variable timeout ; variable laststamp ; variable query ; variable type

		::http::config -proxyfilter "[namespace current]::queue_proxy"

		if {![catch {set token [::http::geturl $newurl -command [namespace current]::queue_done -binary true -timeout $timeout]} errid]} {					
			set reqqueue($token,$id) [list $parser $extra $redir] ; set laststamp(stamp,$id) [unixtime]
		} {return false}

	return true
	}

	proc queue_proxy {url} {
		variable proxy
		if {$proxy ne {}} {return [split $proxy {:}]}		
	return [list]
	}
	
	proc queue_done {token} {
		upvar #0 $token state
		variable reqqueue ; variable maxredir ; variable fetchurl
		
		set errid  [::http::status $token]
		set errstr [::http::error  $token]
		set	id [array  names reqqueue "$token,*"]
		foreach {parser extra redir} $reqqueue($id) {break}
		regsub -- "^$token," $id {} id
	
		while (1) {
			if {$errid == "ok" && [::http::ncode $token] == 302} {
				if {$redir < $maxredir} {			
					array set meta $state(meta)
					if {[info exists meta(Location)]} {queue_add "$fetchurl$meta(Location)" $id $parser $extra [incr redir] ; break}
				} {set errid "error" ; set errstr  "Maxi. redir."}
			} 
			
			if {[catch {$parser {errid} {errstr} {state(body)} {extra}} errid]} {lput putlog $errid "[namespace current] "}
		break
		}
		array unset reqqueue "$token,*"
		::http::cleanup $token

	return
	}

	proc queue_clear_stamps {} {
		variable laststamp ; variable timeout ; variable timerID

		set curr [expr {[unixtime] - 2 * $timeout / 1000}];
		foreach {id} [array names laststamp] {if {$laststamp($id) < $curr} {array unset laststamp $id}}		
		set timerID [timer 10 "[info level 0]"]
	}

	proc cmdaliases {{action {bind}}} {
		foreach {bindtype} {pub msg dcc} {
			foreach {bindproc} [info vars "[namespace current]::${bindtype}:*"] {
				variable "${bindtype}prefix" ; variable "${bindtype}flag"			
				foreach {alias} [set $bindproc] {catch {$action $bindtype [set ${bindtype}flag] [set ${bindtype}prefix]$alias $bindproc}}				
			}
		}
		
	return
	}

	if {[info exists timerID]} {catch {killtimer $timerID} ; catch {unset timerID}}
	[namespace current]::queue_clear_stamps
	[namespace current]::cmdaliases
  	variable sfil [lindex [split [info script] "/"] end]
  	variable modf [clock format [file mtime [info script]] -format "%d-%b-%Y : %H:%M:%S"]
	if {[info exists ::sp_version]} {putlog "[namespace current] v$version (suzi_$sp_version) :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."} {putlog "[namespace current] v$version :: file:$sfil / rel:\[$date\] / mod:\[$modf\] :: by $author :: loaded."}

}
